# Edsger version 1.0.0
# imprudentWalkers.py
# by Antoine Rauzy
# Copyrights (c) 2019 AltaRica Association
#
# This file is part of Edsger, a primitive solver for numerical contraint satisfaction problems.
# Edsger is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# Edsger is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with Edsger.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Main

# 1) Imported modules
# -------------------

import string
import sys
import re
import math

sys.path.insert(0, 'src')

# 2) Main
# -------

def Node(w1, w2, w3, w4, t):
  return "s" + str(w1) + str(w2) + str(w3) + str(w4) + str(t)

def Edge(e, i, j, sw1, sw2, sw3, sw4, st, tw1, tw2, tw3, tw4, tt):
  edge = "e" + str(e) + "(time="
  if i==j:
    edge += "crossingTime" + str(i)
  else:
    edge += "(max crossingTime" + str(i) + " crossingTime" + str(j) + ")"
  edge += "): " + Node(sw1, sw2, sw3, sw4, st) + " -> " + Node(tw1, tw2, tw3, tw4, tt) + ";"
  return edge

resultFileName = "ImprudentWalkers.net"

resultFile = open(resultFileName, "w")
resultFile.write("/*\n")
resultFile.write(" * Imprudent Walkers\n")
resultFile.write(" */\n")
resultFile.write("\n")
resultFile.write("block ImprudentWalkers\n")
resultFile.write("  parameter crossingTime1 = 1;\n")
resultFile.write("  parameter crossingTime2 = 2;\n")
resultFile.write("  parameter crossingTime3 = 5;\n")
resultFile.write("  parameter crossingTime4 = 10;\n")
resultFile.write("  node")
first = True
for t in range(0, 2):
  for w1 in range(0, 2):
    for w2 in range(0, 2):
      for w3 in range(0, 2):
        for w4 in range(0, 2):
          if first:
            first = False
          else:
            resultFile.write(",")
          resultFile.write("\n    " + Node(w1, w2, w3, w4, t))
resultFile.write(";\n")
edge = 0
resultFile.write("  edge\n")
for t in range(0, 2):
  for w1 in range(0, 2):
    for w2 in range(0, 2):
      for w3 in range(0, 2):
        for w4 in range(0, 2):
          if w1==t:
            edge += 1
            resultFile.write("    " + Edge(edge, 1, 1, w1, w2, w3, w4, t, 1-w1, w2, w3, w4, 1-t) + "\n")
          if w2==t:
            edge += 1
            resultFile.write("    " + Edge(edge, 2, 2, w1, w2, w3, w4, t, w1, 1-w2, w3, w4, 1-t) + "\n")
          if w3==t:
            edge += 1
            resultFile.write("    " + Edge(edge, 3, 3, w1, w2, w3, w4, t, w1, w2, 1-w3, w4, 1-t) + "\n")
          if w4==t:
            edge += 1
            resultFile.write("    " + Edge(edge, 4, 4, w1, w2, w3, w4, t, w1, w2, w3, 1-w4, 1-t) + "\n")
          if w1==t and w2==t:
            edge += 1
            resultFile.write("    " + Edge(edge, 1, 2, w1, w2, w3, w4, t, 1-w1, 1-w2, w3, w4, 1-t) + "\n")
          if w1==t and w3==t:
            edge += 1
            resultFile.write("    " + Edge(edge, 1, 3, w1, w2, w3, w4, t, 1-w1, w2, 1-w3, w4, 1-t) + "\n")
          if w1==t and w4==t:
            edge += 1
            resultFile.write("    " + Edge(edge, 1, 4, w1, w2, w3, w4, t, 1-w1, w2, w3, 1-w4, 1-t) + "\n")
          if w2==t and w3==t:
            edge += 1
            resultFile.write("    " + Edge(edge, 2, 3, w1, w2, w3, w4, t, w1, 1-w2, 1-w3, w4, 1-t) + "\n")
          if w2==t and w4==t:
            edge += 1
            resultFile.write("    " + Edge(edge, 2, 4, w1, w2, w3, w4, t, w1, 1-w2, w3, 1-w4, 1-t) + "\n")
          if w3==t and w4==t:
            edge += 1
            resultFile.write("    " + Edge(edge, 3, 4, w1, w2, w3, w4, t, w1, w2, 1-w3, 1-w4, 1-t) + "\n")

resultFile.write("end")
resultFile.flush()
resultFile.close()
