# Edsger version 1.0.0
# Robot.py
# by Antoine Rauzy
# Copyrights (c) 2019 AltaRica Association
#
# This file is part of Edsger, a primitive solver for numerical contraint satisfaction problems.
# Edsger is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# Edsger is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with Edsger.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Main

# 1) Imported modules
# -------------------

import string
import sys
import re
import math

sys.path.insert(0, 'src')

# 2) Main
# -------

def Node(i, j):
  node = "n%02d%02d" % (i, j)
  return node
 
def Edge(e, i, j, k, l):
  edge = "e" + str(e) + "(time=1): " + Node(i, j) + " <-> " + Node(k, l) + ";"
  return edge

numberOfRows = 9
numberOfColumns = 16
grid = [[0 for j in range(0, numberOfColumns)] for i in range(0, numberOfRows)]
grid[2][4] = 1
grid[2][5] = 1
grid[2][6] = 1
grid[3][5] = 1
grid[3][6] = 1
grid[3][7] = 1
grid[3][8] = 1
grid[3][9] = 1
grid[4][6] = 1
grid[4][7] = 1
grid[4][8] = 1
grid[4][9] = 1
grid[5][6] = 1
grid[5][7] = 1
grid[5][8] = 1

resultFileName = "Robot.net"

resultFile = open(resultFileName, "w")
resultFile.write("/*\n")
resultFile.write(" * Robot\n")
resultFile.write(" */\n")
resultFile.write("\n")
resultFile.write("block Robot\n")
resultFile.write("  node")
first = True
for i in range(0, numberOfRows):
  for j in range(0, numberOfColumns):
    if first:
      first = False
    else:
      resultFile.write(",")
    resultFile.write("\n    " + Node(i, j))
resultFile.write(";\n")
edge = 0
resultFile.write("  edge\n")
for i in range(0, numberOfRows):
  for j in range(0, numberOfColumns):
    if grid[i][j]==0:
      if i<numberOfRows-1 and grid[i+1][j]==0:
        edge += 1
        resultFile.write("    " + Edge(edge, i, j, i+1, j) + "\n")
      if j<numberOfColumns-1 and grid[i][j+1]==0:
        edge += 1
        resultFile.write("    " + Edge(edge, i, j, i, j+1) + "\n")

resultFile.write("end")
resultFile.flush()
resultFile.close()
