# Reseda version 1.0.0
# ResedaToken.py
# by Antoine Rauzy
# Copyrights (c) 2018-2021 AltaRica Association
#
# This file is part of Reseda.
# Reseda is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# Reseda is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with Reseda.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Declaration
# 3) Tokens and Keywords

# 1) Imported modules
# -------------------

from S2MLCore import *

# 2) Declaration
# --------------

class ResedaToken(S2MLToken):

# 3) Tokens and Keywords
# ----------------------

  # Tokens
  TOKEN_RIGHT_ARROW = 1101
  TOKEN_LEFT_RIGHT_ARROW = 1102
  TOKEN_VEE = 1111
  TOKEN_WEDGE = 1112

  # Keywords
  KEYWORD_NODE = 1201
  KEYWORD_EDGE = 1202
  KEYWORD_ASSERTION = 1203
  KEYWORD_SET = 1204

  KEYWORD_PARENT_BLOCKS = 1221
  KEYWORD_ANCESTOR_BLOCKS = 1222
  KEYWORD_CHILD_BLOCKS = 1223
  KEYWORD_DESCENDANT_BLOCKS = 1224
  KEYWORD_CHILD_NODES = 1225
  KEYWORD_DESCENDANT_NODES = 1226
  KEYWORD_CHILD_EDGES = 1227
  KEYWORD_DESCENDANT_EDGES = 1228

  KEYWORD_SOURCE_NODES = 1231
  KEYWORD_TARGET_NODES = 1232
  KEYWORD_IN_EDGES = 1233
  KEYWORD_OUT_EDGES = 1234
  KEYWORD_REACHABLE_NODES = 1235
  KEYWORD_COREACHABLE_NODES = 1236

