# Reseda version 1.0.0
# ResedaModelManager.py
# by Antoine Rauzy
# Copyrights (c) 2018-2021 AltaRica Association
#
# This file is part of S2MLCore.
# S2MLCore is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# S2MLCore is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with S2MLCore.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Creator
# 3) Accessors
# 4) Models

# 1) Imported modules
# -------------------

from ResedaModels import *
from ResedaInterface import *

from ResedaModelChecker import *
from ResedaModelFlattener import *
from ResedaModelRewriter import *

# 2) Creator
# ----------

class ResedaModelManager(S2MLModelManager):
  def __init__(self, engine):
    from ResedaEngine import ResedaEngine
    S2MLModelManager.__init__(self, engine)

# 3) Accessors
# ------------

  def CreateTools(self):
    self._modelLexer = ResedaModelLexer(self._engine)
    self._modelParser = ResedaModelParser(self._engine)
    self._modelPrinter = ResedaModelPrinter(self._engine)
    self._modelChecker = ResedaModelChecker(self._engine)
    self._modelFlattener = ResedaModelFlattener(self._engine)
    self._modelRewriter = ResedaModelRewriter(self._engine)

  def NewModel(self):
    return ResedaModel()

