# S2MLCore version 1.2.0
# S2MLDomainDeclaration.py
# by Antoine Rauzy
# Copyrights (c) 2018-2021 AltaRica Association
#
# This file is part of S2MLCore.
# S2MLCore is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# S2MLCore is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with S2MLCore.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Creator
# 3) Accessors

# 1) Imported modules
# -------------------

from S2MLDomains import *
from S2MLMetaModel import *

from S2MLType import *

# 2) Creator
# ----------

class S2MLDomainDeclaration(S2MLElement):
  def __init__(self, identifier, domain, container):
    S2MLElement.__init__(self, S2MLType.DOMAIN_DECLARATION, container)
    self.SetPathAndIdentifierAndInsertInContainerDictionary(identifier)
    self._domain = domain

# 3) Accessors
# ------------

  def GetDomain(self):
    return self._domain

  def SetDomain(self, domain):
    self._domain = domain

