# S2MLCore version 1.2.0
# S2MLIndicatorProfile.py
# by Antoine Rauzy
# Copyrights (c) 2018-2021 AltaRica Association
#
# This file is part of S2MLCore.
# S2MLCore is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# S2MLCore is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with S2MLCore.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Indicator Profiles

# 1) Imported modules
# -------------------

import string
import sys

# 2) Indicator Profiles
# ---------------------

class S2MLIndicatorProfile:
  def __init__(self, name):
    self._name = name
    self._mean = False
    self._standardDeviation = False
    self._confidenceInterval90 = False
    self._confidenceInterval95 = False
    self._confidenceInterval99 = False
    self._extrema = False
    self._quantiles = False
    self._numberOfQuantiles = 0
    self._distribution = False
    self._cumulativeDistribution = False
    self._numberOfPoints = 0
    self._bins = False
    self._numberOfBins = 0
    self._numberOfStoredValues = 0
    self._bootstrapping = False
    self._numberOfSamples = 0
    self._samplingRatio = 0

  def GetName(self):
    return self._name

  def GetMean(self):
    return self._mean
  def SetMean(self, value):
    self._mean = value

  def GetStandardDeviation(self):
    return self._standardDeviation
  def SetStandardDeviation(self, value):
    self._standardDeviation = value

  def GetConfidenceInterval90(self):
    return self._confidenceInterval90
  def SetConfidenceInterval90(self, value):
    self._confidenceInterval90 = value

  def GetConfidenceInterval95(self):
    return self._confidenceInterval95
  def SetConfidenceInterval95(self, value):
    self._confidenceInterval95 = value

  def GetConfidenceInterval99(self):
    return self._confidenceInterval99
  def SetConfidenceInterval99(self, value):
    self._confidenceInterval99 = value

  def GetExtrema(self):
    return self._extrema
  def SetExtrema(self, value):
    self._extrema = value

  def GetQuantiles(self):
    return self._quantiles
  def SetQuantiles(self, value):
    self._quantiles = value

  def GetNumberOfQuantiles(self):
    return self._numberOfQuantiles
  def SetNumberOfQuantiles(self, value):
    self._numberOfQuantiles = value

  def GetDistribution(self):
    return self._distribution
  def SetDistribution(self, value):
    self._distribution = value

  def GetCumulativeDistribution(self):
    return self._cumulativeDistribution
  def SetCumulativeDistribution(self, value):
    self._cumulativeDistribution = value

  def GetNumberOfPoints(self):
    return self._numberOfPoints
  def SetNumberOfPoints(self, value):
    self._numberOfPoints = value

  def GetBins(self):
    return self._bins
  def SetBins(self, value):
    self._bins = value

  def GetNumberOfBins(self):
    return self._numberOfBins
  def SetNumberOfBins(self, value):
    self._numberOfBins = value

  def GetNumberOfStoredValues(self):
    return self._numberOfStoredValues
  def SetNumberOfStoredValues(self, value):
    self._numberOfStoredValues = value

  def GetBootstrapping(self):
    return self._bootstrapping
  def SetBootstrapping(self, value):
    self._bootstrapping = value

  def GetNumberOfSamples(self):
    return self._numberOfSamples
  def SetNumberOfSamples(self, value):
    self._numberOfSamples = value

  def GetSamplingRatio(self):
    return self._samplingRatio
  def SetSamplingRatio(self, value):
    self._samplingRatio = value

  def Clone(self, name):
    clone = S2MLIndicatorProfile(name)
    clone._mean = self._mean
    clone._standardDeviation = self._standardDeviation
    clone._confidenceInterval90 = self._confidenceInterval9
    clone._confidenceInterval95 = self._confidenceInterval95
    clone._confidenceInterval99 = self._confidenceInterval99
    clone._extrema = self._extrema
    clone._quantiles = self._quantiles
    clone._numberOfQuantiles = self._numberOfQuantiles
    clone._distribution = self._distribution
    clone._cumulativeDistribution = self._cumulativeDistribution
    clone._numberOfPoints = self._numberOfPoints
    clone._bins = self._bins
    clone._numberOfBins = self._numberOfBins
    clone._numberOfStoredValues = self._numberOfStoredValues
    clone._bootstrapping = self._bootstrapping
    clone._numberOfSamples = self._numberOfSamples
    clone._samplingRatio = self._samplingRatio
    return clone
